#!/usr/bin/env python
# -*- coding: UTF-8 -*-
# generated by wxGlade 0.4.1 on Wed Feb 21 01:02:39 2007

import wx
from preferences import PanelServers
from preferences import PanelPrefLangs
from preferences import PanelLogin
from preferences import PanelDirectories

import globals,os
import pickle
from xmlrpclib import Transport,Server

class PanelOptions(wx.Panel):
    def __init__(self, *args, **kwds):
        # begin wxGlade: PanelOptions.__init__
        kwds["style"] = wx.TAB_TRAVERSAL
        wx.Panel.__init__(self, *args, **kwds)
        self.notebook = wx.Notebook(self, -1, style=0)
        self.static_line_1 = wx.StaticLine(self, -1)
        self.button_ok = wx.Button(self, -1, _("Apply Changes"))
        self.button_cancel = wx.Button(self, -1, _("Cancel Changes"))

        self.__set_properties()
        self.__do_layout()
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: PanelOptions.__set_properties
        self.button_ok.SetDefault()
        # end wxGlade

    def __do_layout(self):
        # begin wxGlade: PanelOptions.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.notebook, 1, wx.EXPAND, 0)
        sizer_1.Add(self.static_line_1, 0, wx.EXPAND, 0)
        sizer_3.Add(self.button_ok, 0, wx.RIGHT|wx.ADJUST_MINSIZE, 4)
        sizer_3.Add(self.button_cancel, 0, wx.ADJUST_MINSIZE, 0)
        sizer_1.Add(sizer_3, 0, wx.ALIGN_RIGHT, 0)
        self.SetAutoLayout(True)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        sizer_1.SetSizeHints(self)
        # end wxGlade
        self.InitializeComponents()
        
    def InitializeComponents(self):
        
        self.Bind(wx.EVT_BUTTON, self.OnButtonCancel, self.button_cancel)
        self.Bind(wx.EVT_BUTTON, self.OnButtonOK, self.button_ok)
        
        self.LoadPreferences()
	self.notebook.DeleteAllPages()
	self.notebook.AddPage(self.panel_login,_("Login"))
	self.notebook.AddPage(self.panel_server,_("Servers"))
	self.notebook.AddPage(self.panel_language,_("Language"))
	self.notebook.AddPage(self.panel_directories,_("Directories"))
	
	
	
        
    def LoadPreferences(self):
	globals.doing_login = False
        self.preferences_list =  globals.preferences_list

        self.panel_server = PanelServers.PanelServers(self.notebook, -1)
        self.panel_server.Hide()
        if self.preferences_list.has_key("server_osdb"):
            self.panel_server.combo_osdb_server.SetValue(self.preferences_list["server_osdb"])
	if self.preferences_list.has_key("proxyuser"):
            self.panel_server.text_proxyuser.SetValue(self.preferences_list["proxyuser"])
	if self.preferences_list.has_key("proxypass"):
            self.panel_server.text_proxypass.SetValue(self.preferences_list["proxypass"])
	if self.preferences_list.has_key("proxyserver"):
            self.panel_server.text_proxyserver.SetValue(self.preferences_list["proxyserver"])
	if self.preferences_list.has_key("proxyport"):
            self.panel_server.text_proxyport.SetValue(self.preferences_list["proxyport"])
            
            
	self.panel_language = PanelPrefLangs.PanelPrefLangs(self.notebook, -1)
        self.panel_language.Hide()
        if self.preferences_list.has_key("app_language"):
	    self.panel_language.choice_app.SetStringSelection(self.preferences_list["app_language"])
        if self.preferences_list.has_key("upload_language"):
            self.panel_language.choice_upload.SetStringSelection(self.preferences_list["upload_language"])
	if self.preferences_list.has_key("language_upload_autodetect"):
	    self.panel_language.checkbox_autodetect_upload.SetValue(self.preferences_list["language_upload_autodetect"])
	    self.panel_language.OnCheckAutodetectUploadLang(wx.EVT_CHECKBOX)
	    
        if self.preferences_list.has_key("search_langs"):
	    if self.preferences_list["search_langs"] == "all":
		self.panel_language.checkbox_search_all_langs.SetValue(True)
		self.panel_language.scrolled_panel.Disable()
	    else:
		self.panel_language.checkbox_search_all_langs.SetValue(False)
		if self.preferences_list["search_langs"]:
		    for lang in self.preferences_list["search_langs"].split(","):
			self.panel_language.langs_checkboxes[lang].SetValue(True)
		self.panel_language.scrolled_panel.Enable()
		
		    
		
	    
        self.panel_login = PanelLogin.PanelLogin(self.notebook, -1)
        self.panel_login.Hide()
        
        if self.preferences_list.has_key("username"):
            self.panel_login.text_username.SetValue(self.preferences_list["username"])
        if self.preferences_list.has_key("password"):
            self.panel_login.text_password.SetValue(self.preferences_list["password"])
	    
	self.panel_directories = PanelDirectories.PanelDirectories(self.notebook, -1)
        self.panel_directories.Hide()
        
        if self.preferences_list.has_key("download_radio1"):
            self.panel_directories.radio_btn_samedir.SetValue(self.preferences_list["download_radio1"])
	    self.panel_directories.radio_btn_folder.SetValue(not self.preferences_list["download_radio1"])
	if self.preferences_list.has_key("download_folder"):
            self.panel_directories.text_folder.SetValue(self.preferences_list["download_folder"])
                
                
    def OnButtonOK(self,evt):
        wx.BusyInfo("Saving Preferences,please wait...")
	do_login = False
        
	if self.panel_login.text_username.GetValue() != self.preferences_list["username"] \
	    or self.panel_login.text_password.GetValue() != self.preferences_list["password"] \
	    or self.panel_server.combo_osdb_server.GetValue() != self.preferences_list["server_osdb"] \
	    or self.panel_server.text_proxyuser.GetValue() != self.preferences_list["proxyuser"] \
	    or self.panel_server.text_proxypass.GetValue() != self.preferences_list["proxypass"] \
	    or self.panel_server.text_proxyserver.GetValue() != self.preferences_list["proxyserver"] \
	    or self.panel_server.text_proxyport.GetValue() != self.preferences_list["proxyport"]:
	    do_login = True
	   
            
        
	self.preferences_list = globals.preferences_list.copy()
	self.preferences_list["cwd"] = globals.preferences_list["cwd"]
	self.preferences_list["username"] = self.panel_login.text_username.GetValue()
	self.preferences_list["password"] = self.panel_login.text_password.GetValue()
	   
	if self.panel_language.checkbox_search_all_langs.IsChecked():
	    self.preferences_list["search_langs"] = "all"
	else:
	    langs = []
	    for xx,checkbox in self.panel_language.langs_checkboxes.items():
		if checkbox.IsChecked():
		    langs.append(xx)
	    self.preferences_list["search_langs"] = ",".join(langs)
	
	    self.preferences_list["language_upload_autodetect"] = self.panel_language.checkbox_autodetect_upload.GetValue()
	    self.preferences_list["upload_language"] = self.panel_language.choice_upload.GetStringSelection()
	    self.preferences_list["app_language"] = self.panel_language.choice_app.GetStringSelection()
            
        

        self.preferences_list["server_osdb"] = self.panel_server.combo_osdb_server.GetValue()
	
	self.preferences_list["proxyuser"] = self.panel_server.text_proxyuser.GetValue()
	self.preferences_list["proxypass"] = self.panel_server.text_proxypass.GetValue()
	self.preferences_list["proxyserver"] = self.panel_server.text_proxyserver.GetValue()
	self.preferences_list["proxyport"] = self.panel_server.text_proxyport.GetValue()
	
	self.preferences_list["download_radio1"] = self.panel_directories.radio_btn_samedir.GetValue()
	self.preferences_list["download_folder"] = self.panel_directories.text_folder.GetValue()
            
        globals.preferences_list = self.preferences_list
	
		
	try:
            pickle.dump(self.preferences_list,file(os.path.join(globals.sourcefolder,globals.preferences_filename),"wb"))
        except:
            wx.MessageBox("Error trying to save preferences in '" + os.path.join(globals.sourcefolder,globals.preferences_filename) + "'","Error")
	
	if globals.doing_login: #Si hemos entrado a través del menu Login.
	    globals.subdownloaderframe.LoginOSDB(nocookie=True)
	    globals.doing_login = False
	    
	    
	if do_login:
	    dlg = wx.MessageDialog(
		    None,
		    _("Changes will take effect the next time that you login.\nWould you like to do it now ?"),
		    _("Login Again"),
		    wx.YES_NO | wx.ICON_QUESTION 
		    )
	    
	    userChoice = dlg.ShowModal()
	    if userChoice == wx.ID_YES:
		globals.subdownloaderframe.LoginOSDB(nocookie=True)
	
        
    def OnButtonCancel(self,evt):
	#self.panel_directories.Destroy()
	#self.panel_language.Destroy()
	#self.panel_login.Destroy()
	#self.panel_server.Destroy()
	selection = self.notebook.GetSelection()
        self.InitializeComponents()
	self.notebook.SetSelection(selection)
# end of class PanelOptions


