from xmlrpclib import Server,Transport
from httplib import HTTP
import locale
import os
from urlparse import urlparse
from mmpython import *
from types import UnicodeType
import re
import struct


#TESTS
defaultavi = "" 
disable_osdb = True
debugmode = True
use_threads = True
check_update = True
doing_login = False

#CONFIGS
videos_ext = ["avi","mpg","mpeg","wmv","divx","mkv","ogm","asf", "mov", "rm", "vob", "dv", "3ivx"]
subs_ext = ["srt","sub","txt","ssa"]
videos_wildcards = "All videos|*.avi;*.mpg;*.mpeg;*.wmv;*.asf;*.divx;*.mov;*.m2p;*.moov;*.omf;*.qt;*.rm;*.vob;*.dat;*.dv;*.3ivx;*.mkv;*.ogm|ALL files (*.*)|*.*"
    
LOCAL_ENCODING = locale.getpreferredencoding();
if not LOCAL_ENCODING or LOCAL_ENCODING == "ANSI_X3.4-1968":
    LOCAL_ENCODING = 'latin1';

version = "1.2.6"
date_released = "06-03-07"

preferences_filename = "conf/preferences.conf"
update_address = "http://subdownloader.sourceforge.net/subdownloader.update"

preferences_list = {}
sublanguages = {}
update_list = {}


#GLOBAL NEEDED(don't change)
cookiefile = "conf/.cookie"
sourcefolder = ""
app_parameteres = ""

param_function = ""
param_files = []

osdb_token = ""
logged_as = ""
user_has_uploaded = False
xmlrpc_server = ""
proxy_address = None

text_log = None

class GtkTransport (Transport):
    user_agent = "Subdownloader " + version 
    
class ProxiedTransport(Transport):
    user_agent = "Subdownloader " + version 
    def set_proxy(self, proxy):
        self.proxy = proxy
    def make_connection(self, host):
        self.realhost = host
	h = httplib.HTTP(self.proxy)
	return h
    def send_request(self, connection, handler, request_body):
        connection.putrequest("POST", 'http://%s%s' % (self.realhost, handler))
    def send_host(self, connection, host):
        connection.putheader('Host', self.realhost)
	
def MakeOSLink(pagelink,sid=True):
    if preferences_list["server_osdb"].endswith("/"):
	serverosdb = preferences_list["server_osdb"][:-1]
    else:
	serverosdb = preferences_list["server_osdb"]
	
    parsed = urlparse(serverosdb)
    internallink = ""
    sidlink = ""
    if pagelink:
	internallink = "/" + pagelink
    if sid and logged_as:
	sidlink = "/sid-" + osdb_token
    link = parsed[0] + "://" + parsed[1] + internallink + sidlink
    return link 

def CleanString(s):
    garbage = ['_',' ','.',',','(',')']
    for char in garbage:
	s = s.replace(char,'')
    return s

def CleanTagsFile(texto):
    p = re.compile( '<.*?>')
    return p.sub('',texto)

def DeleteExtension(file):
    lastpointposition = file.rfind(".")
    return os.path.basename(file[:lastpointposition])
		
def GetFpsAndTimeMs(path):
    fps = ""
    time_ms = ""
    try: 
	    avi_info = parse(path)
	    if avi_info.video[0].fps > 0:
		   fps = avi_info.video[0].fps

	    if avi_info.length > 0:
		    time_ms = avi_info.length * 1000
		    
	    return fps,time_ms 
    except:
	   return fps,time_ms 
	    

    
def Log(message):
    try:
	string_message = str(message)
	text_log.AppendText("\n" + string_message)
    except:
	pass
    
    
def hashFile(name):
	try:
		
		longlongformat = 'LL'  # signed long, unsigned long
		bytesize = struct.calcsize(longlongformat)
		
		f = file(name, "rb")
		
		filesize = os.path.getsize(name)
		hash = filesize
		
		#print struct.calcsize(longlongformat)
		if filesize < 65536 * 2:
			return "SizeError"
		
		for x in range(65536/bytesize):
			buffer = f.read(bytesize)
			(l2, l1)= struct.unpack(longlongformat, buffer)
			l_value = (long(l1) << 32) | long(l2)
			hash += l_value
			hash = hash & 0xFFFFFFFFFFFFFFFF #to remain as 64bit number
			#if x < 20 : print "%016x" % hash
			
		
		f.seek(max(0,filesize-65536),0)
		for x in range(65536/bytesize):
			buffer = f.read(bytesize)
			(l2, l1) = struct.unpack(longlongformat, buffer)
			l_value = (long(l1) << 32) | long(l2)
			hash += l_value
			hash = hash & 0xFFFFFFFFFFFFFFFF
	
		f.close()
		returnedhash =  "%016x" % hash
		return returnedhash
		
	except(IOError):
		return "IOError"
	

def EncodeLocale(phrase):
    if not isinstance(phrase, UnicodeType):
            phrase = unicode(phrase.decode("latin1","ignore"))
    return phrase

def getAddress(file):
	filename = EncodeLocale(os.path.basename(file))
	filenameurl = (filename) #Corrects the accent characters.
	
	if not os.path.exists(file):
		return "NotFoundError"
	else:
		hash = hashFile(file)
		if hash == "IOError" or hash== "SizeError":
			return hash
		
		#We keep going if there was no error.
		filesize = "%016x" % os.path.getsize(file)
		wwwparameters="name[0]=" + filenameurl + "&size[0]=" + filesize + "&hash[0]=" + hash
		
		
		
		linkplaintext_index = preferences_list["server_isdb"] + "index.php" + "?player=mpc&" + wwwparameters
		
		videofilesize = os.path.getsize(file)
		linkhtml_index =  "search/moviebytesize-"+str(videofilesize)+"/moviehash-"+hash
		videofilename = filename
		pathvideofilename = file
		videohash = hash
		return {"hash":hash, "filename":filename, "pathvideofilename":file, "filesize":str(videofilesize)
			, "linkhtml_index":linkhtml_index , "linkplaintext_index":linkplaintext_index}

