#!/usr/bin/env python
"""wxPython Runtime Environment"""

import sys
import os

__version__ = "0.2.1"

def getversion():
    """returns wxPRE version, including the wx version if available"""
    try:
        import wx
        return "%s-wx%s-mingw" % (__version__, wx.VERSION_STRING)
    except ImportError:
        return __version__

def addpathsfromdir(dirname):
    """looks in the directory for .pth files and adds them to sys.path"""
    for direntry in os.listdir(dirname):
        if os.path.splitext(direntry)[1] == '.pth':
            pthfile = open(os.path.join(dirname, direntry), 'r')
            pthdirs = [pthdir.strip() for pthdir in pthfile.readlines()]
            pthfile.close()
            for pthdir in pthdirs:
                if os.path.isdir(pthdir):
                    sys.path.append(pthdir)

if __name__ == "__main__":
    import sys
    if len(sys.argv) > 1:
        arg = sys.argv[1]
        if arg == "--version":
            print sys.argv[0], getversion()
        elif arg == "--test":
            print repr(sys.path)
            print repr(sys.prefix)
            print repr(sys.executable)
            print repr(getattr(sys, "frozen", None))
            print repr(getattr(locals, "__file__", None))
            print repr(sys.argv)
        else:
            filename = os.path.abspath(arg)
            addpathsfromdir(os.path.dirname(filename))
            addpathsfromdir(os.getcwd())
            sys.argv = sys.argv[1:]
            #make sure the current path is the required one
            #and that imports can be made
            path = os.path.dirname(filename)
            if path is not os.getcwd():
                os.chdir(path)
            if path not in sys.path:
                sys.path.append(path)
            try:
                execfile(filename)
            except ImportError,detail:
                print >>sys.stderr, "wxPRE ImportError: ",detail
                print >>sys.stderr, "Try adding a .pth file here or in the scripts dir."
                raise
    else:
        print >>sys.stderr, "Need to supply script filename for %s (version %s)" % (sys.argv[0], getversion())